using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Routing;
using Microsoft.AspNetCore.Authorization;
using Microsoft.Extensions.Logging;
using Sockeye.Models;
using Sockeye.Api.ControllerHelpers;
using Sockeye.Biz;



namespace Sockeye.Api.Controllers
{
    [ApiController]
    [ApiVersion("8.0")]
    [Route("api/v{version:apiVersion}/form-user-options")]
    [Produces("application/json")]
    [Authorize]
    public class FormUserOptionsController : ControllerBase
    {
        private readonly AyContext ct;
        private readonly ILogger<FormUserOptionsController> log;
        private readonly ApiServerState serverState;

        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="dbcontext"></param>
        /// <param name="logger"></param>
        /// <param name="apiServerState"></param>  
        public FormUserOptionsController(AyContext dbcontext, ILogger<FormUserOptionsController> logger, ApiServerState apiServerState)
        {
            ct = dbcontext;
            log = logger;
            serverState = apiServerState;
        }

        /// <summary>
        /// Create or Replace FormUserOptions
        /// </summary>
        /// <param name="newObject"></param>
        /// <param name="apiVersion">From route path</param>
        /// <returns></returns>
        [HttpPost]
        public async Task<IActionResult> PostFormUserOptions([FromBody] FormUserOptions newObject, ApiVersion apiVersion)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));
            FormUserOptionsBiz biz = FormUserOptionsBiz.GetBiz(ct, HttpContext);
            if (!Authorized.HasCreateRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());
            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));
            FormUserOptions o = await biz.UpsertAsync(newObject);
            if (o == null)
                return BadRequest(new ApiErrorResponse(biz.Errors));
            else
                return CreatedAtAction(nameof(FormUserOptionsController.GetFormUserOptions), new { formKey = o.FormKey, version = apiVersion.ToString() }, new ApiCreatedResponse(o));
        }


        /// <summary>
        /// Get FormUserOptions
        /// </summary>
        /// <param name="formKey"></param>
        /// <returns>FormUserOptions</returns>
        [HttpGet("{formKey}")]
        public async Task<IActionResult> GetFormUserOptions([FromRoute] string formKey)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));
            FormUserOptionsBiz biz = FormUserOptionsBiz.GetBiz(ct, HttpContext);
            if (!Authorized.HasReadFullRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());
            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));
            var o = await biz.GetAsync(formKey);
           //note: this route unique in that it's expected that a formUserOptions object may not exist so just return null as client end expects
            return Ok(ApiOkResponse.Response(o));
        }

        // /// <summary>
        // /// Update FormUserOptions
        // /// </summary>        
        // /// <param name="updatedObject"></param>
        // /// <returns></returns>
        // [HttpPut]
        // public async Task<IActionResult> PutFormUserOptions([FromBody] FormUserOptions updatedObject)
        // {
        //     if (!serverState.IsOpen)
        //         return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));
        //     if (!ModelState.IsValid)
        //         return BadRequest(new ApiErrorResponse(ModelState));
        //     FormUserOptionsBiz biz = FormUserOptionsBiz.GetBiz(ct, HttpContext);
        //     if (!Authorized.HasModifyRole(HttpContext.Items, biz.BizType))
        //         return StatusCode(403, new ApiNotAuthorizedResponse());
        //     var o = await biz.PutAsync(updatedObject);
        //     if (o == null)
        //     {
        //         if (biz.Errors.Exists(z => z.Code == ApiErrorCode.CONCURRENCY_CONFLICT))
        //             return StatusCode(409, new ApiErrorResponse(biz.Errors));
        //         else
        //             return BadRequest(new ApiErrorResponse(biz.Errors));
        //     }
        //     return Ok(ApiOkResponse.Response(new { Concurrency = o.Concurrency })); ;
        // }

        /// <summary>
        /// Delete FormUserOptions
        /// </summary>
        /// <param name="formKey"></param>
        /// <returns>NoContent</returns>
        [HttpDelete("{formKey}")]
        public async Task<IActionResult> DeleteFormUserOptions([FromRoute] string formKey)
        {
            if (!serverState.IsOpen)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));
            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));
            FormUserOptionsBiz biz = FormUserOptionsBiz.GetBiz(ct, HttpContext);
            if (!Authorized.HasDeleteRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());
            if (!await biz.DeleteAsync(formKey))
                return BadRequest(new ApiErrorResponse(biz.Errors));
            return NoContent();
        }



        //------------


    }//eoc
}//eons